package enseirb.myinpulse.controller;

import enseirb.myinpulse.model.LCSection;
import enseirb.myinpulse.model.Project;
import enseirb.myinpulse.service.EntrepreneurApiService;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.web.bind.annotation.*;

@SpringBootApplication
@RestController
public class EntrepreneurApi {

    private final EntrepreneurApiService entrepreneurApiService;

    @Autowired
    EntrepreneurApi(EntrepreneurApiService entrepreneurApiService) {
        this.entrepreneurApiService = entrepreneurApiService;
    }

    /**
     * TODO: check return type
     *
     * <p>Endpoint used to update a LC section.
     *
     * @return status code
     */
    @PutMapping("/entrepreneur/lcsection/modify/{sectionId}")
    public void editLCSection(@PathVariable String sectionId, @RequestBody LCSection section) {
        entrepreneurApiService.editLCSection(sectionId, section);
    }

    /**
     * TODO: checkReturn Type
     *
     * <p>Endpoint used to delete a LC section
     *
     * @return status code
     */
    @DeleteMapping("/entrepreneur/lcsection/remove/{sectionId}")
    public void removeLCSection(@PathVariable String sectionId) {
        entrepreneurApiService.removeLCSection(sectionId);
    }

    /**
     * TODO: check return type
     *
     * <p>Endpoint used to create a new LC section
     *
     * @return status code
     */
    @PostMapping("/entrepreneur/lcsection/add/{sectionId}")
    public void addLCSection(@PathVariable String sectionId, @RequestBody LCSection section) {
        entrepreneurApiService.addLCSection(sectionId, section);
    }

    /**
     * TODO: check return type
     *
     * <p>Endpoint used to request the creation of a new project
     *
     * @return status code
     */
    @PostMapping("/entrepreneur/project/request")
    public void requestNewProject(@RequestBody Project project) {
        entrepreneurApiService.requestNewProject(project);
    }
}
