package enseirb.myinpulse.service.database.old_controllers_to_convert_to_services;

import enseirb.myinpulse.model.Administrateurs;
import enseirb.myinpulse.repository.AdministrateursRepository;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.server.ResponseStatusException;

import java.util.Optional;

@RestController
public class AdministrateursController {

    @Autowired AdministrateursRepository administrateursRepository;

    @GetMapping("/Administrateurs")
    @ResponseBody
    public Iterable<Administrateurs> allAdministrateurs() {
        return this.administrateursRepository.findAll();
    }

    @GetMapping("/Administrateurs/{id}")
    public Administrateurs getAdministrateursById(@PathVariable Long id) {
        Optional<Administrateurs> administrateur = this.administrateursRepository.findById(id);
        if (administrateur.isEmpty()) {
            throw new ResponseStatusException(
                    HttpStatus.NOT_FOUND, "Cet administrateur n'existe pas");
        }
        return administrateur.get();
    }

    @PostMapping("/Administrateurs")
    public Administrateurs addAdministrateurs(@RequestBody Administrateurs administrateurs) {
        return this.administrateursRepository.save(administrateurs);
    }
}
